1 # Test framework for git. See t/README for usage.
3 # Copyright (c) 2005 Junio C Hamano
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see http://www.gnu.org/licenses/ .
18 # Keep the original TERM for say_color
21 # Test the binaries we have just built. The tests are kept in
22 # t/ subdirectory and are run in 'trash directory' subdirectory.
23 if test -z "$TEST_DIRECTORY"
25 # We allow tests to override this, in case they want to run tests
26 # outside of t/, e.g. for running tests on the test library
30 # ensure that TEST_DIRECTORY is an absolute path so that it
31 # is valid even if the current working directory is changed
32 TEST_DIRECTORY
=$
(cd "$TEST_DIRECTORY" && pwd) ||
exit 1
34 if test -z "$TEST_OUTPUT_DIRECTORY"
36 # Similarly, override this to store the test-results subdir
38 TEST_OUTPUT_DIRECTORY
=$TEST_DIRECTORY
40 GIT_BUILD_DIR
="$TEST_DIRECTORY"/..
42 ################################################################
43 # It appears that people try to run tests without building...
44 "$GIT_BUILD_DIR/git" >/dev
/null
47 echo >&2 'error: you do not seem to have built git yet.'
51 .
"$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
52 export PERL_PATH SHELL_PATH
54 # if --tee was passed, write the output not only to the terminal, but
55 # additionally to the file test-results/$BASENAME.out, too.
56 case "$GIT_TEST_TEE_STARTED, $* " in
58 # do not redirect again
60 *' --tee '*|
*' --va'*)
61 mkdir
-p "$TEST_OUTPUT_DIRECTORY/test-results"
62 BASE
="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)"
63 (GIT_TEST_TEE_STARTED
=done ${SHELL_PATH} "$0" "$@" 2>&1;
64 echo $?
> $BASE.
exit) |
tee $BASE.out
65 test "$(cat $BASE.exit)" = 0
70 # For repeatability, reset the environment to known value.
76 export LANG LC_ALL PAGER TERM TZ
78 # A call to "unset" with no arguments causes at least Solaris 10
79 # /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
80 # deriving from the command substitution clustered with the other
82 unset VISUAL EMAIL LANGUAGE COLUMNS $
("$PERL_PATH" -e '
84 my $ok = join("|", qw(
96 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
97 print join("\n", @vars);
101 GIT_AUTHOR_EMAIL
=author@example.com
102 GIT_AUTHOR_NAME
='A U Thor'
103 GIT_COMMITTER_EMAIL
=committer@example.com
104 GIT_COMMITTER_NAME
='C O Mitter'
105 GIT_MERGE_VERBOSITY
=5
106 GIT_MERGE_AUTOEDIT
=no
107 export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
108 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
109 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
112 # Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
114 export GIT_TRACE_BARE
116 if test -n "${TEST_GIT_INDEX_VERSION:+isset}"
118 GIT_INDEX_VERSION
="$TEST_GIT_INDEX_VERSION"
119 export GIT_INDEX_VERSION
122 # Add libc MALLOC and MALLOC_PERTURB test
123 # only if we are not executing the test with valgrind
124 if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev
/null ||
125 test -n "$TEST_NO_MALLOC_CHECK"
127 setup_malloc_check
() {
130 teardown_malloc_check
() {
134 setup_malloc_check
() {
135 MALLOC_CHECK_
=3 MALLOC_PERTURB_
=165
136 export MALLOC_CHECK_ MALLOC_PERTURB_
138 teardown_malloc_check
() {
139 unset MALLOC_CHECK_ MALLOC_PERTURB_
143 # Protect ourselves from common misconfiguration to export
144 # CDPATH into the environment
150 case $
(echo $GIT_TRACE |
tr "[A-Z]" "[a-z]") in
152 echo "* warning: Some tests will not work if GIT_TRACE" \
153 "is set as to trace on STDERR ! *"
154 echo "* warning: Please set GIT_TRACE to something" \
155 "other than 1, 2 or true ! *"
161 # A regexp to match 5 and 40 hexdigits
162 _x05
='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
163 _x40
="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
166 _z40
=0000000000000000000000000000000000000000
172 export _x05 _x40 _z40 LF
174 # Each test should start with something like this, after copyright notices:
176 # test_description='Description of this test...
177 # This test checks if command xyzzy does the right thing...
180 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
181 TERM
=$ORIGINAL_TERM &&
184 tput bold
>/dev
/null
2>&1 &&
185 tput setaf
1 >/dev
/null
2>&1 &&
186 tput sgr0
>/dev
/null
2>&1
190 while test "$#" -ne 0
193 -d|
--d|
--de|
--deb|
--debu|
--debug)
195 -i|
--i|
--im|
--imm|
--imme|
--immed|
--immedi|
--immedia|
--immediat|
--immediate)
196 immediate
=t
; shift ;;
197 -l|
--l|
--lo|
--lon|
--long|
--long-|
--long-t|
--long-te|
--long-tes|
--long-test|
--long-tests)
198 GIT_TEST_LONG
=t
; export GIT_TEST_LONG
; shift ;;
200 shift; test "$#" -ne 0 ||
{
201 echo 'error: -r requires an argument' >&2;
204 run_list
=$1; shift ;;
206 run_list
=$
(expr "z$1" : 'z[^=]*=\(.*\)'); shift ;;
207 -h|
--h|
--he|
--hel|
--help)
209 -v|
--v|
--ve|
--ver|
--verb|
--verbo|
--verbos|
--verbose)
212 verbose_only
=$
(expr "z$1" : 'z[^=]*=\(.*\)')
214 -q|
--q|
--qu|
--qui|
--quie|
--quiet)
215 # Ignore --quiet under a TAP::Harness. Saying how many tests
216 # passed without the ok/not ok details is always an error.
217 test -z "$HARNESS_ACTIVE" && quiet
=t
; shift ;;
219 with_dashes
=t
; shift ;;
222 --va|
--val|
--valg|
--valgr|
--valgri|
--valgrin|
--valgrind)
226 valgrind
=$
(expr "z$1" : 'z[^=]*=\(.*\)')
229 valgrind_only
=$
(expr "z$1" : 'z[^=]*=\(.*\)')
232 shift ;; # was handled already
234 root
=$
(expr "z$1" : 'z[^=]*=\(.*\)')
241 echo "error: unknown test option '$1'" >&2; exit 1 ;;
245 if test -n "$valgrind_only"
247 test -z "$valgrind" && valgrind
=memcheck
248 test -z "$verbose" && verbose_only
="$valgrind_only"
249 elif test -n "$valgrind"
262 tput bold
; tput setaf
1;; # bold red
264 tput setaf
4;; # blue
266 tput setaf
3;; # brown/yellow
268 tput setaf
2;; # green
270 tput setaf
6;; # cyan
272 test -n "$quiet" && return;;
282 test -z "$1" && test -n "$quiet" && return
289 say_color error
"error: $*"
298 test "${test_description}" != "" ||
299 error
"Test script did not set test_description."
301 if test "$help" = "t"
303 printf '%s\n' "$test_description"
309 if test "$verbose" = "t"
313 exec 4>/dev
/null
3>/dev
/null
322 test_external_has_tap
=0
326 if test -n "$GIT_EXIT_OK"
330 echo >&5 "FATAL: Unexpected exit with code $code"
338 # The user-facing functions are loaded from a separate file so that
339 # test_perf subshells can have them too
340 .
"$TEST_DIRECTORY/test-lib-functions.sh"
342 # You are not expected to call test_ok_ and test_failure_ directly, use
343 # the test_expect_* functions instead.
346 test_success
=$
(($test_success + 1))
347 say_color
"" "ok $test_count - $@"
351 test_failure
=$
(($test_failure + 1))
352 say_color error
"not ok $test_count - $1"
354 printf '%s\n' "$*" |
sed -e 's/^/# /'
355 test "$immediate" = "" ||
{ GIT_EXIT_OK
=t
; exit 1; }
358 test_known_broken_ok_
() {
359 test_fixed
=$
(($test_fixed+1))
360 say_color error
"ok $test_count - $@ # TODO known breakage vanished"
363 test_known_broken_failure_
() {
364 test_broken
=$
(($test_broken+1))
365 say_color warn
"not ok $test_count - $@ # TODO known breakage"
369 test "$debug" = "" ||
eval "$1"
372 match_pattern_list
() {
375 test -z "$*" && return 1
386 match_test_selector_list
() {
391 test -z "$1" && return 0
393 # Both commas and whitespace are accepted as separators.
399 # If the first selector is negative we include by default.
407 orig_selector
=$selector
413 selector
=${selector##?}
417 test -z "$selector" && continue
421 if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev
/null
423 echo "error: $title: invalid non-numeric in range" \
424 "start: '$orig_selector'" >&2
427 if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev
/null
429 echo "error: $title: invalid non-numeric in range" \
430 "end: '$orig_selector'" >&2
435 if expr "z$selector" : "z[0-9]*[^0-9]" >/dev
/null
437 echo "error: $title: invalid non-numeric in test" \
438 "selector: '$orig_selector'" >&2
443 # Short cut for "obvious" cases
444 test -z "$include" && test -z "$positive" && continue
445 test -n "$include" && test -n "$positive" && continue
449 if test $arg -le ${selector#-}
455 if test $arg -ge ${selector%-}
461 if test ${selector%%-*} -le $arg \
462 && test $arg -le ${selector#*-}
468 if test $arg -eq $selector
479 maybe_teardown_verbose
() {
480 test -z "$verbose_only" && return
481 exec 4>/dev
/null
3>/dev
/null
486 maybe_setup_verbose
() {
487 test -z "$verbose_only" && return
488 if match_pattern_list
$test_count $verbose_only
491 # Emit a delimiting blank line when going from
492 # non-verbose to verbose. Within verbose mode the
493 # delimiter is printed by test_expect_*. The choice
494 # of the initial $last_verbose is such that before
495 # test 1, we do not print it.
496 test -z "$last_verbose" && echo >&3 ""
499 exec 4>/dev
/null
3>/dev
/null
502 last_verbose
=$verbose
505 maybe_teardown_valgrind
() {
506 test -z "$GIT_VALGRIND" && return
507 GIT_VALGRIND_ENABLED
=
510 maybe_setup_valgrind
() {
511 test -z "$GIT_VALGRIND" && return
512 if test -z "$valgrind_only"
514 GIT_VALGRIND_ENABLED
=t
517 GIT_VALGRIND_ENABLED
=
518 if match_pattern_list
$test_count $valgrind_only
520 GIT_VALGRIND_ENABLED
=t
524 # This is a separate function because some tests use
525 # "return" to end a test_expect_success block early
526 # (and we want to make sure we run any cleanup like
528 test_eval_inner_
() {
529 # Do not add anything extra (including LF) after '$*'
531 test \"$trace\" = t && set -x
536 # We run this block with stderr redirected to avoid extra cruft
537 # during a "-x" trace. Once in "set -x" mode, we cannot prevent
538 # the shell from printing the "set +x" to turn it off (nor the saving
539 # of $? before that). But we can make sure that the output goes to
542 # The test itself is run with stderr put back to &4 (so either to
543 # /dev/null, or to the original stderr if --verbose was used).
545 test_eval_inner_
"$@" </dev
/null
>&3 2>&4
550 if test "$test_eval_ret_" != 0
552 say_color error
>&4 "error: last command exited with \$?=$test_eval_ret_"
556 return $test_eval_ret_
565 teardown_malloc_check
567 if test -z "$immediate" ||
test $eval_ret = 0 ||
568 test -n "$expecting_failure" && test "$test_cleanup" != ":"
571 test_eval_
"$test_cleanup"
572 teardown_malloc_check
574 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
582 test_count
=$
(($test_count+1))
589 maybe_teardown_valgrind
590 maybe_teardown_verbose
596 if match_pattern_list
$this_test.
$test_count $GIT_SKIP_TESTS
599 skipped_reason
="GIT_SKIP_TESTS"
601 if test -z "$to_skip" && test -n "$test_prereq" &&
602 ! test_have_prereq
"$test_prereq"
607 if test "$missing_prereq" != "$test_prereq"
609 of_prereq
=" of $test_prereq"
611 skipped_reason
="missing $missing_prereq${of_prereq}"
613 if test -z "$to_skip" && test -n "$run_list" &&
614 ! match_test_selector_list
'--run' $test_count "$run_list"
617 skipped_reason
="--run"
622 say_color skip
>&3 "skipping test: $@"
623 say_color skip
"ok $test_count # skip $1 ($skipped_reason)"
632 # stub; perf-lib overrides it
633 test_at_end_hook_
() {
640 if test -z "$HARNESS_ACTIVE"
642 test_results_dir
="$TEST_OUTPUT_DIRECTORY/test-results"
643 mkdir
-p "$test_results_dir"
645 test_results_path
="$test_results_dir/${base%.sh}-$$.counts"
647 cat >>"$test_results_path" <<-EOF
649 success $test_success
657 if test "$test_fixed" != 0
659 say_color error
"# $test_fixed known breakage(s) vanished; please update test(s)"
661 if test "$test_broken" != 0
663 say_color warn
"# still have $test_broken known breakage(s)"
665 if test "$test_broken" != 0 ||
test "$test_fixed" != 0
667 test_remaining
=$
(( $test_count - $test_broken - $test_fixed ))
668 msg
="remaining $test_remaining test(s)"
670 test_remaining
=$test_count
671 msg
="$test_count test(s)"
673 case "$test_failure" in
675 # Maybe print SKIP message
676 if test -n "$skip_all" && test $test_count -gt 0
678 error
"Can't use skip_all after running some tests"
680 [ -z "$skip_all" ] || skip_all
=" # SKIP $skip_all"
682 if test $test_external_has_tap -eq 0
684 if test $test_remaining -gt 0
686 say_color pass
"# passed all $msg"
688 say
"1..$test_count$skip_all"
691 test -d "$remove_trash" &&
692 cd "$(dirname "$remove_trash")" &&
693 rm -rf "$(basename "$remove_trash")"
700 if test $test_external_has_tap -eq 0
702 say_color error
"# failed $test_failure among $msg"
711 if test -n "$valgrind"
715 test "$1" = "$(readlink "$2")" ||
{
723 while test -d "$2".lock
725 say
"Waiting for lock on $2."
732 make_valgrind_symlink
() {
733 # handle only executables, unless they are shell libraries that
734 # need to be in the exec-path.
736 test "# " = "$(head -c 2 <"$1")" ||
739 base
=$
(basename "$1")
740 symlink_target
=$GIT_BUILD_DIR/$base
741 # do not override scripts
742 if test -x "$symlink_target" &&
743 test ! -d "$symlink_target" &&
744 test "#!" != "$(head -c 2 < "$symlink_target")"
746 symlink_target
=..
/valgrind.sh
750 symlink_target
=..
/unprocessed-script
752 # create the link, or replace it if it is out of date
753 make_symlink
"$symlink_target" "$GIT_VALGRIND/bin/$base" ||
exit
756 # override all git executables in TEST_DIRECTORY/..
757 GIT_VALGRIND
=$TEST_DIRECTORY/valgrind
758 mkdir
-p "$GIT_VALGRIND"/bin
759 for file in $GIT_BUILD_DIR/git
* $GIT_BUILD_DIR/test-
*
761 make_valgrind_symlink
$file
763 # special-case the mergetools loadables
764 make_symlink
"$GIT_BUILD_DIR"/mergetools
"$GIT_VALGRIND/bin/mergetools"
769 ls "$path"/git-
* 2> /dev
/null |
772 make_valgrind_symlink
"$file"
776 PATH
=$GIT_VALGRIND/bin
:$PATH
777 GIT_EXEC_PATH
=$GIT_VALGRIND/bin
779 GIT_VALGRIND_MODE
="$valgrind"
780 export GIT_VALGRIND_MODE
781 GIT_VALGRIND_ENABLED
=t
782 test -n "$valgrind_only" && GIT_VALGRIND_ENABLED
=
783 export GIT_VALGRIND_ENABLED
784 elif test -n "$GIT_TEST_INSTALLED"
786 GIT_EXEC_PATH
=$
($GIT_TEST_INSTALLED/git
--exec-path) ||
787 error
"Cannot run git from $GIT_TEST_INSTALLED."
788 PATH
=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
789 GIT_EXEC_PATH
=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
790 else # normal case, use ../bin-wrappers only unless $with_dashes:
791 git_bin_dir
="$GIT_BUILD_DIR/bin-wrappers"
792 if ! test -x "$git_bin_dir/git"
794 if test -z "$with_dashes"
796 say
"$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
800 PATH
="$git_bin_dir:$PATH"
801 GIT_EXEC_PATH
=$GIT_BUILD_DIR
802 if test -n "$with_dashes"
804 PATH
="$GIT_BUILD_DIR:$PATH"
807 GIT_TEMPLATE_DIR
="$GIT_BUILD_DIR"/templates
/blt
808 GIT_CONFIG_NOSYSTEM
=1
810 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
812 if test -z "$GIT_TEST_CMP"
814 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
816 GIT_TEST_CMP
="$DIFF -c"
818 GIT_TEST_CMP
="$DIFF -u"
822 GITPERLLIB
="$GIT_BUILD_DIR"/perl
/blib
/lib
:"$GIT_BUILD_DIR"/perl
/blib
/arch
/auto
/Git
824 test -d "$GIT_BUILD_DIR"/templates
/blt ||
{
825 error
"You haven't built things yet, have you?"
828 if ! test -x "$GIT_BUILD_DIR"/test-chmtime
830 echo >&2 'You need to build test-chmtime:'
831 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
836 TRASH_DIRECTORY
="trash directory.$(basename "$0" .sh)"
837 test -n "$root" && TRASH_DIRECTORY
="$root/$TRASH_DIRECTORY"
838 case "$TRASH_DIRECTORY" in
839 /*) ;; # absolute path is good
840 *) TRASH_DIRECTORY
="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
842 test ! -z "$debug" || remove_trash
=$TRASH_DIRECTORY
843 rm -fr "$TRASH_DIRECTORY" ||
{
845 echo >&5 "FATAL: Cannot prepare test area"
849 HOME
="$TRASH_DIRECTORY"
850 GNUPGHOME
="$HOME/gnupg-home-not-used"
851 export HOME GNUPGHOME
853 if test -z "$TEST_NO_CREATE_REPO"
855 test_create_repo
"$TRASH_DIRECTORY"
857 mkdir
-p "$TRASH_DIRECTORY"
859 # Use -P to resolve symlinks in our working directory so that the cwd
860 # in subprocesses like git equals our $PWD (for pathname comparisons).
861 cd -P "$TRASH_DIRECTORY" ||
exit 1
864 this_test
=${this_test%%-*}
865 if match_pattern_list
"$this_test" $GIT_SKIP_TESTS
867 say_color info
>&3 "skipping test $this_test altogether"
868 skip_all
="skip all tests in $this_test"
872 # Provide an implementation of the 'yes' utility
887 # Fix some commands on Windows
890 # Windows has its own (incompatible) sort and find
900 # git sees Windows-style pwd
904 # no POSIX permissions
905 # backslashes in pathspec are converted to '/'
906 # exec does not inherit the PID
907 test_set_prereq MINGW
908 test_set_prereq NATIVE_CRLF
909 test_set_prereq SED_STRIPS_CR
910 test_set_prereq GREP_STRIPS_CR
911 GIT_TEST_CMP
=mingw_test_cmp
914 test_set_prereq POSIXPERM
915 test_set_prereq EXECKEEPSPID
916 test_set_prereq CYGWIN
917 test_set_prereq SED_STRIPS_CR
918 test_set_prereq GREP_STRIPS_CR
921 test_set_prereq POSIXPERM
922 test_set_prereq BSLASHPSPEC
923 test_set_prereq EXECKEEPSPID
927 ( COLUMNS
=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
928 test -z "$NO_PERL" && test_set_prereq PERL
929 test -z "$NO_PYTHON" && test_set_prereq PYTHON
930 test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
931 test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
933 # Can we rely on git's output in the C locale?
934 if test -n "$GETTEXT_POISON"
936 GIT_GETTEXT_POISON
=YesPlease
937 export GIT_GETTEXT_POISON
938 test_set_prereq GETTEXT_POISON
940 test_set_prereq C_LOCALE_OUTPUT
943 # Use this instead of test_cmp to compare files that contain expected and
944 # actual output from git commands that can be translated. When running
945 # under GETTEXT_POISON this pretends that the command produced expected
948 test -n "$GETTEXT_POISON" || test_cmp
"$@"
951 # Use this instead of "grep expected-string actual" to see if the
952 # output from a git command that can be translated either contains an
953 # expected string, or does not contain an unwanted one. When running
954 # under GETTEXT_POISON this pretends that the command produced expected
957 if test -n "$GETTEXT_POISON"
960 elif test "x!" = "x$1"
969 test_lazy_prereq PIPE
'
970 # test whether the filesystem supports FIFOs
976 rm -f testfifo && mkfifo testfifo
981 test_lazy_prereq SYMLINKS
'
982 # test whether the filesystem supports symbolic links
983 ln -s x y && test -h y
986 test_lazy_prereq FILEMODE
'
987 test "$(git config --bool core.filemode)" = true
990 test_lazy_prereq CASE_INSENSITIVE_FS
'
991 echo good >CamelCase &&
992 echo bad >camelcase &&
993 test "$(cat CamelCase)" != good
996 test_lazy_prereq UTF8_NFD_TO_NFC
'
997 # check whether FS converts nfd unicode to nfc
998 auml=$(printf "\303\244")
999 aumlcdiar=$(printf "\141\314\210")
1009 test_lazy_prereq AUTOIDENT
'
1010 sane_unset GIT_AUTHOR_NAME &&
1011 sane_unset GIT_AUTHOR_EMAIL &&
1012 git var GIT_AUTHOR_IDENT
1015 test_lazy_prereq EXPENSIVE
'
1016 test -n "$GIT_TEST_LONG"
1019 test_lazy_prereq USR_BIN_TIME
'
1020 test -x /usr/bin/time
1023 # When the tests are run as root, permission tests will report that
1024 # things are writable when they shouldn't be.
1025 test -w / || test_set_prereq SANITY
1027 GIT_UNZIP
=${GIT_UNZIP:-unzip}
1028 test_lazy_prereq UNZIP
'